<?php
/* 
* Author Notes: Please leave all comments and author information. 
* License: Freeware - For Personal and Business use - DO NOT CHANGE ANYTHING EXCEPT THE CONFIGURATION ARRAY AND CONFIGURATION VARIABLES. 
* 			You are NOT allowed to redistribute this project without permission from the original author.
* WARRANTY: Comes with no warranty or gaurantee of performance. Use at your own risk.
* Author: Danny Bench - Source Port Services
* Website: http://sourceportservices.com
* Revision Date: 10/4/2010
* Version: 1.3
*/

/*
*     ---------- Configuration Instructions -------------
* -Only edit the $servers array variable! 
* -This is the area that you will edit to reflect the Servers/Systems you want to monitor.
* -If you would like to add more systems make sure there is a comma ',' after each array() 
*   statement.
*
* -Your array() settings should follow the example on the next line.
*   array('Server Display Name','IP address or HOST name or Domain name', port#, timeout_in_seconds)
*	More Examples:
*   array('Internet Connection','www.google.com', 80, 3) //Code to monitor access to the Internet on HTTP port 80
*   array('Webserver 1','192.168.0.1', 80, 3) //Code to monitor a webserver on HTTP port 80
*   array('Webserver 1','web_svr_1', 80, 3) //Code to monitor a webserver using it's hostname on HTTP port 80
*   array('Email Server','10.0.0.64', 25, 3) //Code to monitor a email server on SMTP port 25
*/
$servers = array (
		array('Internet Connection', 'www.google.com', 80, 3),
		array('Main Website', 'example.com', 80, 3),
		array('Email SMTP Service', 'mail.example.com', 25, 3),
		array('Email POP3 Service', 'mail.example.com', 110, 3),
		array('Local - D. Gateway/Wifi Router', '192.168.1.1', 80, 3),
		array('Local - Webserver', '192.168.1.5', 80, 3),
);


// Auto Refresh feature Configuration
$autorefresh_feature = 0; //Enabled=1, Disabled=0
$refresh_delay = 1800000; //Time in miliseconds, 1000 Miliseconds = 1 Second. Example: 600000 Miliseconds = 600 seconds or 10 minutes


// Email Alerting feature, works best when running tool from a real mail server with Public IP address to prevent backlisting.
// You will only receive Email alerts to device failures. 
// You will receive an email according to the $refresh_delay variable or every time you reload the SPS Server Monitor page. 
// Until all devices are contacted properly or you remove the problem device from the list above.
$emailalerting_feature = 0; //Enabled=1, Disabled=0
$from = "SPS Server Monitor <webmaster@example.com>"; //Valid Email Address linked to the SMTP Username below on the SMTP server in $host var below.
$to = array(); //DO NOT EDIT THIS LINE
$to[] = "IT Admin <webmaster@example.com>"; //Edit this line to reflect your Display Name and Email address in between the " "
//$to[] = "IT Tech <emailaddress@example.com>"; // Uncomment and Edit this line to add another recipient

// SMTP authentication params
$host = "mail.example.com";
$username = "webmaster@example.com";
$password = "yourpassword";










// ****************************************************************************************
// ***					    DO NOT EDIT ANYTHING BELOW THIS LINE.						***
// ***					System Varibles and Programming Below this line					***
// ****************************************************************************************

// Get Current Server Time
$curdatetime = date('Y-m-d H:i:s');



//Run Main Loop to check all servers list in the array for status.
	//Reset $failure_count var to 0
	$failure_count = 0;
foreach ($servers as $server){
$fp = @fsockopen($server[1], $server[2], $errno, $errstr, $server[3]);
	//If statement to show IF server status is UP or DOWN
	if(!$fp){
	$server_stat_str = $server_stat_str."<tr><td>{$server[0]}</td><td>{$server[1]}</td><td>{$server[2]}</td><td><span class='status_down'>DOWN</span></td><td><img src='down.gif' /></td></tr>";
	$failed_devices[$failure_count] = array($server[0], $server[1], $server[2]);
	$failure_count = $failure_count + 1;
	} else {
	$server_stat_str = $server_stat_str."<tr><td>{$server[0]}</td><td>{$server[1]}</td><td>{$server[2]}</td><td><span class='status_up'>UP</span></td><td><img src='up.gif' /></td></tr>";	
	}
}
//Process the Failure Results and send Alert Email to Administrator if Email alerting is enabled
if($emailalerting_feature == 1 AND $failure_count >= 1){
	//Create TEXT version only of email message
	$body = <<<EOM
*** SPS Server Monitor has sent you a status report. ***\n
*** Listed below are network Servers/Devices that could not be reached. ***\n\n
EOM;
foreach ($failed_devices as $server){
$body .= "Device Name: $server[0], IP: $server[1], Port: $server[2], Status: DOWN \n\n";
}
$body .= <<<EOM
*** Please notify the Network Administrator ASAP about this outage. *** \n
EOM;
//echo $email_message; //Only use to debug what email message will look like.

	
require_once "Mail.php";
 
$subject = "SPS Server Monitor Status Report";

$headers = array ('From' => $from,
   'To' => $to,
   'Subject' => $subject);
 $smtp = Mail::factory('smtp',
   array ('host' => $host,
     'auth' => true,
     'username' => $username,
     'password' => $password));
 
 $mail = $smtp->send($to, $headers, $body);

if (PEAR::isError($mail)) {
   $email_sent = $mail->getMessage();
  } else {
   $email_sent = "Yes";
  }

} else {
   //No Failures, No Email Sent
   $email_sent = "No";
}






//Auto Refresh feature Code below
if($autorefresh_feature == 1){
	$autorefresh_status = "Enabled";
	$refresh_delay_sec = $refresh_delay / 1000;
	$refresh_delay_min = $refresh_delay_sec / 60;
	$autorefreshhtml_output = <<<ETO
	<table cellspacing=0 cellpadding=1 align="center" class="results_table">
	<tr class="table_head"><td colspan="5" style="text-align:center;color:darkblue;">
	<p><strong>Auto Refresh Feature</strong></p>
	<tr class="table_head"><td width="30%">
	<strong>Variable Name</strong>
	</td><td>
	<strong>Value</strong>
	</td></tr>
	<tr><td>
	\$autorefresh_feature
	</td><td>
	<span class='status_up'>{$autorefresh_feature} ({$autorefresh_status})</span>
	</td></tr>
	<tr><td>
	\$refresh_delay
	</td><td title='1000 ms = 1 sec'>
	{$refresh_delay}ms/{$refresh_delay_sec}seconds/{$refresh_delay_min}minutes
	</td></tr>
	</table><br />
	<!-- Javascript to auto refresh the page. -->
	<script type="text/javascript">
		<!--
		setTimeout('window.location.reload()', {$refresh_delay});
		//-->
	</script>
ETO;
} else {
	$autorefresh_status = "Disabled";
	$autorefreshhtml_output = <<<ETO
	<table cellspacing=0 cellpadding=1 align="center" class="results_table">
	<tr class="table_head"><td colspan="5" style="text-align:center;color:darkblue;">
	<p><strong>Auto Refresh Feature</strong></p>
	<tr class="table_head"><td width="30%">
	<strong>Variable Name</strong>
	</td><td>
	<strong>Value</strong>
	</td></tr>
	<tr><td>
	\$autorefresh_feature
	</td><td>
	<span class='status_down'>{$autorefresh_feature} ({$autorefresh_status})</span>
	</td></tr>
	<tr><td>
	\$refresh_delay
	</td><td title='1000 ms = 1 sec'>
	{$refresh_delay} (Time in Miliseconds)
	</td></tr>
	</table><br />
ETO;
}

//Email Alerting feature Code below
if($emailalerting_feature == 1){
	$emailalerting_status = "Enabled";
	$to_output = htmlentities(implode(", ",$to));
	$emailalertinghtml_output = <<<ETO
	<table cellspacing=0 cellpadding=1 align="center" class="results_table">
	<tr class="table_head"><td colspan="5" style="text-align:center;color:darkblue;">
	<p><strong>Email Alerting Feature</strong></p>
	<tr class="table_head"><td width="30%">
	<strong>Variable Name</strong>
	</td><td>
	<strong>Value</strong>
	</td></tr>
	<tr><td>
	\$emailalerting_feature
	</td><td>
	<span class='status_up'>{$emailalerting_feature} ({$emailalerting_status})</span>
	</td></tr>
	<tr><td>
	\$to (Send Emails To)
	</td><td>
	{$to_output}
	</td></tr>
	<tr><td>
	Alert Email Sent
	</td><td>
	{$email_sent}
	</td></tr>
	</table><br />
ETO;
} else {
	$emailalerting_status = "Disabled";
	$to_output = htmlentities(implode(", ",$to));
	$emailalertinghtml_output = <<<ETO
	<table cellspacing=0 cellpadding=1 align="center" class="results_table">
	<tr class="table_head"><td colspan="5" style="text-align:center;color:darkblue;">
	<p><strong>Email Alerting Feature</strong></p>
	<tr class="table_head"><td width="30%">
	<strong>Variable Name</strong>
	</td><td>
	<strong>Value</strong>
	</td></tr>
	<tr><td>
	\$emailalerting_feature
	</td><td>
	<span class='status_down'>{$emailalerting_feature} ({$emailalerting_status})</span>
	</td></tr>
	<tr><td>
	\$to (Send Emails To)
	</td><td>
	{$to_output}
	</td></tr>
	<tr><td>
	Alert Email Sent
	</td><td>
	{$email_sent}
	</td></tr>
	</table><br />
ETO;
}


?>

<html>
<head>
<title>SPS - Server Monitoring Tool v1.3 Free</title>

<style type="text/css">
#main_container
{
text-align:center;
width:700px;
}

.results_table
{
width:700px;
}

table td
{
border: 1px;
border-style:solid;
border-color:darkblue;
}

.table_head
{
background-color:lightblue;
}

.status_down
{
color:red;
font-weight:bold;
}

.status_up
{
color:green;
font-weight:bold;
}
</style>

</head>


<body>

<div id="main_container">
<p><h2>SPS - Server Monitoring Tool v1.3 Free</h2></p>
<br />

<table cellspacing=0 cellpadding=1 align="center" class="results_table">
<tr class="table_head"><td title="Current status of network devices" colspan="5" style="text-align:center;color:darkblue;">
<p><strong>Current Status of Network, Last Refreshed On: <?php echo $curdatetime;?></strong></p>
<tr class="table_head"><td title="Human Readable Display Name">
<strong>Resource Name</strong>
</td><td title="IP, Domain Name, or HOSTNAME used to connect to the server.">
<strong>IP Address</strong>
</td><td width=50 title="Listening Server Port that this tool uses to check status">
<strong>Port #</strong>
</td><td width=50 title="UP - Server is online and accessible, DOWN - Server not accessible or turned off.">
<strong>Status</strong>
</td><td width=100 title="Connection Status Indicator">
<strong>Status Light</strong>
</td></tr>
<?php
//Show Main Loop for all servers listed in the array for status.
echo $server_stat_str;
?>
</table>
<br />



<?php
//Show Auto Refresh feature status and settings
echo $autorefreshhtml_output;

//Show Email Alerting feature status and settings
echo $emailalertinghtml_output;

?>





<br /><br /><br /><br />
<p><span style="font-size: 12px;">Designed By: <a href="http://sourceportservices.com" target="_blank">Source Port Services</a> &copy; 2010</p>
</div>


</body>
</html>